package de.oaa.xxx.aufgaben.controller;

import de.oaa.xxx.aufgaben.Strafe;
import de.oaa.xxx.aufgaben.entity.AufgabenGruppeEntity;
import de.oaa.xxx.aufgaben.entity.StrafeEntity;
import de.oaa.xxx.aufgaben.repository.AufgabenGruppeRepository;
import de.oaa.xxx.aufgaben.repository.StrafeRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.util.UUID;

@RestController
@RequestMapping("/strafe")
@Transactional
public class StrafeController {

    private static final Logger LOGGER = LoggerFactory.getLogger(StrafeController.class);

    private final StrafeRepository strafeRepository;
    private final AufgabenGruppeRepository gruppeRepository;

    public StrafeController(StrafeRepository strafeRepository, AufgabenGruppeRepository gruppeRepository) {
        this.strafeRepository = strafeRepository;
        this.gruppeRepository = gruppeRepository;
    }

    @GetMapping("/{strafeId}")
    public ResponseEntity<Strafe> get(@PathVariable UUID strafeId) {
        return strafeRepository.findById(strafeId)
                .map(entity -> ResponseEntity.ok(entity.toStrafe()))
                .orElse(ResponseEntity.noContent().build());
    }

    @PostMapping
    public ResponseEntity<Void> create(@RequestBody Strafe strafe) {
        if (strafe.getKurzText() == null || strafe.getText() == null || strafe.getLevel() == null || strafe.getGruppeId() == null) {
            return ResponseEntity.badRequest().build();
        }
        AufgabenGruppeEntity gruppeEntity = gruppeRepository.findById(strafe.getGruppeId()).orElse(null);
        if (gruppeEntity == null || gruppeEntity.getAufgaben().size() > 50) {
            return ResponseEntity.badRequest().build();
        }
        StrafeEntity entity = StrafeEntity.create(strafe, gruppeEntity);
        strafeRepository.save(entity);
        return ResponseEntity.created(
                ServletUriComponentsBuilder.fromCurrentRequest().path("/{id}").buildAndExpand(entity.getStrafeId()).toUri()
        ).build();
    }

    @DeleteMapping
    public ResponseEntity<Void> delete(@RequestBody Strafe strafe) {
        try {
            strafeRepository.findById(strafe.getStrafeId()).ifPresent(strafeRepository::delete);
            return ResponseEntity.accepted().build();
        } catch (Exception exception) {
            LOGGER.error(exception.getMessage(), exception);
            return ResponseEntity.internalServerError().build();
        }
    }
}
